#
# Conditional build:
%bcond_without	tests	# do not perform "make test"
#

# see Makefile.PL /blacklist, choose first OK version to ensure skipping all broken releases
%define	libxml2_ver	1:2.9.6

%include	/usr/lib/rpm/macros.perl
%define		pdir	XML
%define		pnam	LibXML
Summary:	XML::LibXML - interface to the GNOME libxml2 library
Summary(pl.UTF-8):	XML::LibXML - interfejs do biblioteki libxml2 z GNOME
Name:		perl-XML-LibXML
Version:	2.0132
Release:	3
# same as perl
License:	GPL v1+ or Artistic
Group:		Development/Languages/Perl
Source0:	http://www.cpan.org/modules/by-module/XML/%{pdir}-%{pnam}-%{version}.tar.gz
# Source0-md5:	43546fd9a3974f19323f9fb04861ece9
URL:		http://search.cpan.org/dist/XML-LibXML/
BuildRequires:	libxml2-devel >= %{libxml2_ver}
BuildRequires:	perl-ExtUtils-MakeMaker >= 6.56
BuildRequires:	perl-XML-NamespaceSupport >= 1.07
BuildRequires:	perl-XML-SAX >= 0.11
BuildRequires:	perl-devel >= 1:5.8.0
BuildRequires:	rpm-perlprov >= 4.1-13
%if %{with tests}
BuildRequires:	iconv
BuildRequires:	perl-Test-Simple
%endif
Requires:	libxml2 >= %{libxml2_ver}
Requires:	perl-XML-NamespaceSupport >= 1.07
Requires:	perl-XML-SAX >= 0.11
Provides:	perl-XML-LibXML-XPathContext = %{version}
Obsoletes:	perl-XML-LibXML-Common
Obsoletes:	perl-XML-LibXML-XPathContext <= 0:0.07
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
This module implements much of the DOM Level 2 API as an interface to
the GNOME libxml2 library. This makes it a fast and highly capable
validating XML parser library, as well as a high performance DOM.

%description -l pl.UTF-8
Ten moduł to implementacja większości API DOM Level 2 jako interfejsu
do biblioteki GNOME libxml2. Daje to szybki i mający duże możliwości
analizator sprawdzający poprawność XML-a, a także wysoko wydajny DOM.

%package SAX
Summary:	XML::LibXML::SAX Perl module - XML::LibXML direct SAX parser
Summary(pl.UTF-8):	Moduł Perla XML::LibXML::SAX - bezpośredni analizator SAX z XML::LibXML
Group:		Development/Languages/Perl
Requires:	%{name} = %{version}-%{release}

%description SAX
This class allows you to generate SAX2 events using LibXML. Note that
this is not a stream based parser, instead it parses documents into a
DOM and traverses the DOM tree. The reason being that libxml2's stream
based parsing is extremely primitive, and would require an extreme
amount of work to allow SAX2 parsing in a stream manner.

%description SAX -l pl.UTF-8
Ta klasa pozwala generować zdarzenia SAX2 przy użyciu LibXML2. To nie
jest analizator oparty na strumieniach - przetwarza dokumenty na DOM i
następnie wędruje po drzewie DOM. Wynika to z faktu, że w libxml2
analiza oparta na strumieniach jest bardzo prymitywna i wymagałaby
wiele pracy, aby umożliwić strumieniową analizę SAX2.

%prep
%setup -q -n %{pdir}-%{pnam}-%{version}

%build
SKIP_SAX_INSTALL=true;
export SKIP_SAX_INSTALL

%{__perl} Makefile.PL \
	INSTALLDIRS=vendor
%{__make} \
	CC="%{__cc}" \
	OPTIMIZE="%{rpmcflags}"

%{?with_tests:%{__make} test}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT
install example/{*.pl,*.xml,*.dtd,*.xhtml} $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}

install -d $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}/complex
install example/complex/{*.xml,*.dtd} $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}/complex

install -d $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}/complex/dtd
install example/complex/dtd/*.dtd $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}/complex/dtd

# mans are provided
%{__rm} $RPM_BUILD_ROOT%{perl_vendorarch}/XML/{LibXML.pod,LibXML/*.pod,LibXML/SAX/*.pod}

%clean
rm -rf $RPM_BUILD_ROOT

%post SAX
umask 022
%{__perl} -MXML::SAX -e "XML::SAX->add_parser(q(XML::LibXML::SAX::Parser))->save_parsers()"

%preun SAX
if [ "$1" = "0" ]; then
	umask 022
	%{__perl} -MXML::SAX -e "XML::SAX->remove_parser(q(XML::LibXML::SAX::Parser))->save_parsers()"
fi

%files
%defattr(644,root,root,755)
%doc Changes LICENSE README TODO
%{perl_vendorarch}/XML/LibXML.pm
%dir %{perl_vendorarch}/XML/LibXML
%{perl_vendorarch}/XML/LibXML/[!S]*.pm
%dir %{perl_vendorarch}/auto/XML/LibXML
%attr(755,root,root) %{perl_vendorarch}/auto/XML/LibXML/LibXML.so
%{_mandir}/man3/XML::LibXML.3pm*
%{_mandir}/man3/XML::LibXML::[!S]*
%{_mandir}/man3/XML::LibXML::S[!A]*
%dir %{_examplesdir}/%{name}-%{version}
%attr(755,root,root) %{_examplesdir}/%{name}-%{version}/x*.pl
%{_examplesdir}/%{name}-%{version}/[!x]*

%files SAX
%defattr(644,root,root,755)
%dir %{perl_vendorarch}/XML/LibXML/SAX
%{perl_vendorarch}/XML/LibXML/SAX.pm
%{perl_vendorarch}/XML/LibXML/SAX/*.pm
%{_mandir}/man3/XML::LibXML::SAX.3pm*
%{_mandir}/man3/XML::LibXML::SAX::*
%changelog
* Thu Aug 30 2018 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/perl-XML-LibXML.git;a=log;h=master

* Thu Aug 30 2018 Jan Rękorajski <baggins@pld-linux.org> 4ce426a
- rebuild with perl 5.28.0
- release 3 (by relup.sh)

* Tue Jun 19 2018 Jakub Bogusz <qboosh@pld-linux.org> fd0625b
- release 2

* Sat Dec 23 2017 Jakub Bogusz <qboosh@pld-linux.org> 20c092b
- updated to 2.0132 (2.0119 fixed CVE-2015-3451 in 2015...)

* Sun Jun 11 2017 Jan Rękorajski <baggins@pld-linux.org> 11de2a1
- perl req/prov fix
- release 3 (by relup.sh)

* Sun Jun 11 2017 Jan Rękorajski <baggins@pld-linux.org> cc19b35
- rebuild with perl 5.26
- release 2 (by relup.sh)

* Sun Oct 30 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> 3d8f017
- up to 2.0118

* Sun Oct 30 2016 Jan Rękorajski <baggins@pld-linux.org> 27f2083
- rebuild with perl 5.24.0
- release 4 (by relup.sh)

* Thu Dec 24 2015 Jan Rękorajski <baggins@pld-linux.org> 449d36e
- release 3 (by relup.sh)

* Thu Feb 26 2015 Jan Rękorajski <baggins@pld-linux.org> 9a8f311
- x32 rebuild
- release 2 (by relup.sh)

* Mon Feb 02 2015 Jakub Bogusz <qboosh@pld-linux.org> 793a16d
- updated to 2.0117

* Fri Sep 12 2014 Jan Rękorajski <baggins@pld-linux.org> e4daa3a
- release 3 (by relup.sh)

* Fri Sep 12 2014 Jan Rękorajski <baggins@pld-linux.org> dd51671
- removed zero-sized .bs file

* Fri Sep 12 2014 Jan Rękorajski <baggins@pld-linux.org> bae9f19
- rebuild for perl 5.20
- release 2 (by relup.sh)

* Sat Jun 22 2013 Jakub Bogusz <qboosh@pld-linux.org> ca6c438
- updated to 2.0018

* Sat Jun 08 2013 Jan Rękorajski <baggins@pld-linux.org> 4e1b5a2
- rebuild with perl 5.18.0
- release 2 (by relup.sh)

* Tue Oct 30 2012 Jakub Bogusz <qboosh@pld-linux.org> d91c82a
- updated to 2.0008

* Sun Jan 22 2012 zbyniu <zbyniu@pld-linux.org> 49411a7
- up to 1.90

* Sun Jan 15 2012 zbyniu <zbyniu@pld-linux.org> edb5e07
- up to 1.75

* Tue Oct 04 2011 lisu <lisu@pld-linux.org> bfe269d
- rel 7

* Thu Jan 27 2011 sparky <sparky@pld-linux.org> e5d57ec
- dropped unused BR: gdome2-devel, pkgconfig
- tests BR: iconv

